// TCP/IP Stack Javascript Library. http://www.kernelchip.ru
// Version: 3.01 
var timeOutMS = 5000; //ms 
var ajaxList = new Array();

function newAJAXCommand(url, container, repeat, data)
{	
var newAjax = new Object();
var theTimer = new Date();
newAjax.url = url;
newAjax.container = container;
newAjax.repeat = repeat;
newAjax.ajaxReq = null;	
	
	if(window.XMLHttpRequest) {
        newAjax.ajaxReq = new XMLHttpRequest();
        newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
        newAjax.ajaxReq.send(data); 
    } else if(window.ActiveXObject) {
        newAjax.ajaxReq = new ActiveXObject("Microsoft.XMLHTTP");
        if(newAjax.ajaxReq) {
            newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
            newAjax.ajaxReq.send(data);
        }
    }    
    newAjax.lastCalled = theTimer.getTime();   
    ajaxList.push(newAjax);
}

function pollAJAX() {
	
	var curAjax = new Object();
	var theTimer = new Date();
	var elapsed;	

	for(i = ajaxList.length; i > 0; i--)
	{
		curAjax = ajaxList.shift();
		if(!curAjax)
			continue;
		elapsed = theTimer.getTime() - curAjax.lastCalled;				
	
		if(curAjax.ajaxReq.readyState == 4 && curAjax.ajaxReq.status == 200) {			
			if(typeof(curAjax.container) == 'function'){
			    if (curAjax.ajaxReq.responseXML) curAjax.container(curAjax.ajaxReq.responseXML.documentElement);
			    else if (curAjax.ajaxReq.response) curAjax.container(curAjax.ajaxReq.response);
			} else if(typeof(curAjax.container) == 'string') {
				document.getElementById(curAjax.container).innerHTML = curAjax.ajaxReq.responseText;
			} 
			
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;
			
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}	
		
		if(elapsed > timeOutMS) {			
			if(typeof(curAjax.container) == 'function'){
				curAjax.container(null);
			} else {				
				//alert("Command failed.\nConnection to Jerome board was lost.");
			}

	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;
						
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}		
		ajaxList.push(curAjax);
	}	
	setTimeout("pollAJAX()", 100);	
}			

function getXMLValue(xmlData, field) {
	try {
		if(xmlData.getElementsByTagName(field)[0].firstChild.nodeValue)
			return xmlData.getElementsByTagName(field)[0].firstChild.nodeValue;
		else
			return null;
	} catch(err) { return null; }
}

setTimeout("pollAJAX()", 500);

/////////////////////////////////////////////////////////////////////
// Types of SLOW information
var SLOW_INFO_SN            = 1;
var SLOW_INFO_FW            = 2;
var SLOW_INFO_JIOTABLE      = 3;
var SLOW_INFO_IP            = 4;
var SLOW_INFO_MAC           = 5;
var SLOW_INFO_MSK           = 6;
var SLOW_INFO_GTW           = 7;
var SLOW_INFO_SPB           = 8;
var SLOW_INFO_EXTSRV        = 9;
var SLOW_INFO_BITSET        = 10;
var SLOW_INFO_PSW           = 11;
var SLOW_INFO_COUNT_CYCLES  = 12;
var SLOW_INFO_TOTAL         = 13;
/////////////////////////////////////////////////////////////////////

function CatcherObject() {
  this.eCatType     = 0;        
  this.bEnabled     = 0;        
  this.bExtServer   = 0;
    
  this.timer        = 0;
  this.uiInLine     = 0;
  this.LineEvtType  = 0;
  this.uiExtraParam = 0;
    
  this.uiOutLineNumber  = 0; 
  this.uiOutValue   = 0;      
  this.uiOutDelay   = 0;    
    
  this.cnt = 0;
}
var CAT_ARRAY_SIZE = 20;

function JeromeObject() {
  this.Connected  = 0;      // 0 - disconnected, 1 - connected
  this.time      =  0;      // SystemTime
  this.sn        = "";      // Serial Number
  this.fw        = "";      // Firmware version
  this.pwm       = 0;       // PWM level  
  
  this.IOTableSave = new Array(); // States of IO lines (in/out) 
  this.IOValueSave = new Array(); // Values for IO lines (0/1)
    
  this.ADC  = new Array();        // ADC, 4 channels
  this.INT  = new Array();        // Impuls counter, 4 channels
  this.INTCycle  = new Array();   // Impuls counter cycles, 4 channels

  // Catcher ARRAY
  this.cat = new Array();
  for( i = 0; i < CAT_ARRAY_SIZE; i++) {
      this.cat[i] = new CatcherObject();
  }
  var bCatcherInfoNew = 0;
  var bCatcherCntNew  = 0;
  var bSlowInfoNew    = 0;
  
  this.pass = "";
  this.ip   = "";
  this.mac  = "";
  this.mask = "";
  this.gate = "";
  this.baud = "";
  this.security = true;  // Security is ON
  this.fw_load  = false; // FW upload is disabled
  this.sav      = false; // Values saving is disabled
  this.rmt_srv  = "";    // Remote Server adress
  this.kevt = false; // $KE,EVT is OFF by default
  this.dzg = false;
  
  for( i = 0; i < 22; i++ ) {
    this.IOTableSave[i] = 0;
    this.IOValueSave[i] = 0;
  }
    
  for( i = 0; i < 4; i++ ) {
    this.ADC[i] = 0;
    this.INT[i] = 0; 
    this.INTCycle[i] = 0; 
  }
    
  this.IsConnected = function() { return this.Connected; }
  this.GetTime = function() { return this.time; } 
  this.GetSN = function() { return this.sn; }  
  this.GetFW = function() { return this.fw; }
  this.GetPWM = function() { return this.pwm; }      
  this.GetADC = function(n) { return this.ADC[n]; }
  this.GetINT = function(n) { return this.INT[n]; }
  this.GetINTCycle = function(n) { return this.INTCycle[n]; }
  this.GetIoTable = function(n) { return this.IOTableSave[n]; }
  this.GetIoValue = function(n) { return this.IOValueSave[n]; } 
  
  this.GetPass = function() { return this.pass; }
  this.GetIP   = function() { return this.ip; }
  this.GetMAC  = function() { return this.mac; } 
  this.GetMask = function() { return this.mask; } 
  this.GetGate = function() { return this.gate; } 
  this.GetBaud = function() { return this.baud; } 
  
  this.GetSEC = function() { return this.security; } 
  this.GetFWL = function() { return this.fw_load; }
  this.GetSAV = function() { return this.sav; }
  this.GetKEVT = function () { return this.kevt; }
  this.GetDZG = function () { return this.dzg; }

  var srv = "server.cgi?data";

  this.Ready = function(){ 
  newAJAXCommand(srv+'=OKK,'); }

  this.SetIO = function(LineIdx){ 
  newAJAXCommand(srv+'=SIO,'+LineIdx); }

  this.SetOUT = function(LineIdx,Value){
  newAJAXCommand(srv+'=OUT,'+LineIdx+','+Value);}

  this.SetPWM = function(NewPwm){ 
  newAJAXCommand(srv+'=PWM,'+NewPwm);}  

  this.SetPass = function(value){  
  newAJAXCommand(srv+'=PAS,' + value);}

  this.SetIP = function(value){ 
  newAJAXCommand(srv+'=IPX,' + value + '$');}

  this.SetMAC = function(value){ 
  newAJAXCommand(srv+'=MAC,' + value + '$');}

  this.SetMSK = function(value){ 
  newAJAXCommand(srv+'=MSK,' + value + '$');}
  
  this.SetGTW = function(value){ 
  newAJAXCommand(srv+'=GTW,' + value + '$');}
  
  this.SetSEC = function(value){ 
  newAJAXCommand(srv+'=SEC,' + value);}  
  
  this.SetSAV = function(value){ 
    newAJAXCommand(srv+'=SAV,' + value);}

  this.SetKEVT = function(value){ 
    newAJAXCommand(srv + '=KEVT,' + value);
  }

  this.SetDZG = function (value) {
    newAJAXCommand(srv + '=DZG,' + value);
  }

  this.SetBaud = function(value){
  newAJAXCommand(srv+'=BAU,' + value);}
  
  this.SendUSART = function(value, cr_lf){
  newAJAXCommand(srv+'=USR,' + cr_lf + ',' + value.length + ',' + value);}

  this.Reset = function(){
  newAJAXCommand(srv+'=RST');}

  this.Default = function(){
  newAJAXCommand(srv+'=DEF');} 

  this.SetCAT_ALL_Action = function( action ) {
    // All CAT
    newAJAXCommand(srv+'=ACAT,' + action );
  }

  this.SetCAT_I_Action = function( idx, action ) {
    // CAT for particulr slot
    newAJAXCommand(srv+'=ICAT,' + idx + ',' + action  );
  }

  this.SetCAT_New = function( mes ) {
    // NEW CAT 
    newAJAXCommand(srv+'=NCAT,' + mes  );
  }
      
  this.UpdateCAT_Info = function () {
    newAJAXCommand(srv + '=UCAT');
  }
      
  this.UpdateStatus = function(xmlData){   
  if( !xmlData ) { this.Connected = 0; return; }  
  
  this.Connected = 1;

  var TempLoc;

  TempLoc = getXMLValue(xmlData, 'systime0');
  if (TempLoc) this.time = TempLoc;   
  
  var IoTempValue = getXMLValue(xmlData, 'iovalue0');
  if (IoTempValue) {
      for (i = 0; i < 22; i++) this.IOValueSave[i] = IoTempValue.charAt(i);
  }
  
  for (i = 0; i < 4; i++) {
    TempLoc = getXMLValue(xmlData, 'adc' + i);
    if (TempLoc) this.ADC[i] = TempLoc;
  }
  for (i = 0; i < 4; i++) {
     TempLoc = getXMLValue(xmlData, 'count' + i);
     if (TempLoc) this.INT[i] = TempLoc;
  }  

  TempLoc = getXMLValue(xmlData, 'pwm0');
  if (TempLoc) this.pwm = TempLoc;

  // Slow information...
  TempLoc = getXMLValue(xmlData, 'slow_info0');
  if (TempLoc) {
      // <data id>,<data>
      var TempArr = TempLoc.split(',');
      if (TempArr.length != 2) return;
      switch ( parseInt(TempArr[0]) ) {
          case SLOW_INFO_SN: {
              this.sn = TempArr[1];
              break;
          }
          case SLOW_INFO_FW: {
              this.fw = TempArr[1];
              break;
          }
          case SLOW_INFO_JIOTABLE: {
              for (i = 0; i < 22; i++) {
                  this.IOTableSave[i] = TempArr[1].charAt(i);
              }
              break;
          }
          case SLOW_INFO_IP: {
              this.ip = TempArr[1];
              break;
          }
          case SLOW_INFO_MAC: {
              this.mac = TempArr[1];
              break;
          }
          case SLOW_INFO_MSK: {
              this.mask = TempArr[1];
              break;
          }
          case SLOW_INFO_GTW: {
              this.gate = TempArr[1];
              break;
          }
          case SLOW_INFO_SPB: {
              this.baud = parseInt(TempArr[1]);
              break;
          }
          case SLOW_INFO_EXTSRV: {
              this.rmt_srv = TempArr[1];
              break;
          }         
          case SLOW_INFO_BITSET: {
            // Security, SAV, EVT, DZG
            this.security = false;
            this.sav = false;
            this.kevt = false;
            this.dzg = false;
            var ch = TempArr[1].charAt(0);
            if (ch == '1') this.security = true;
            ch = TempArr[1].charAt(1);
            if (ch == '1') this.sav = true;
            ch = TempArr[1].charAt(2);
            if (ch == '1') this.kevt = true;
            ch = TempArr[1].charAt(3);
            if (ch == '1') this.dzg = true;
            break;
          }          
          case SLOW_INFO_PSW: {
              this.pass = TempArr[1];
              break;
          }
          case SLOW_INFO_COUNT_CYCLES: {
              // INT Cycle Counts, 4 x items
              // cyc1;cyc2;cyc3;cyc4

              var TempCycArr = TempArr[1].split(';');
              // No more than 4 x int ciunters are possible
              if (TempCycArr.length > 4) return;
              for (i = 0; i < TempCycArr.length; i++) {
                  this.INTCycle[i] = TempCycArr[i];
              }                            
              break;
          }         
      }   // end Switch     
  } // IF valid data

  ////////////////////////////////////////////////////////////
  // Catcher information...
  TempLoc = getXMLValue(xmlData, 'cat_inf0');
  if(TempLoc) {
      //if( pCAT->eCatType == 'L' ) {      
      //    sprintf( Buff, "%d,%d,%c,%d,%d,%d,%d,%d", bo.bCATInfoChanged-1, pCAT->bEnabled, pCAT->eCatType, 
      //        pCAT->evt.uiInLine, pCAT->evt.LineEvtType, pCAT->uiOutLineNumber, pCAT->uiOutValue, pCAT->bExtServer );      
      //}

      
      var TempArr = TempLoc.split(',');
      var len = TempArr.length;

      var idx = parseInt(TempArr[0]);      

      if( idx > CAT_ARRAY_SIZE-1 ) return;      

      this.cat[idx].bEnabled = parseInt(TempArr[1]);
      this.cat[idx].eCatType = TempArr[2];
      if( TempArr[2] == "L" ){
        this.cat[idx].uiInLine    = parseInt(TempArr[3]);
        this.cat[idx].LineEvtType = parseInt(TempArr[4]);     
          
        this.cat[idx].uiOutLineNumber = parseInt(TempArr[5]);
        this.cat[idx].uiOutValue = parseInt(TempArr[6]);
        //this.cat[idx].bExtServer = parseInt(TempArr[7]);
      }
      else if( TempArr[2] == "T" ){
          this.cat[idx].timer = parseInt(TempArr[3]); 
          this.cat[idx].uiOutLineNumber = parseInt(TempArr[4]);
          this.cat[idx].uiOutValue = parseInt(TempArr[5]);
          //this.cat[idx].bExtServer = parseInt(TempArr[6]);
          this.cat[idx].uiOutDelay = parseInt(TempArr[6]);
      } 
      else if( TempArr[2] == "Z" ){
          // Slot is ZERO
          this.cat[idx].eCatType        = 0;        
          this.cat[idx].bEnabled        = 0;        
          this.cat[idx].bExtServer      = 0;    
          this.cat[idx].timer           = 0;
          this.cat[idx].uiInLine        = 0;
          this.cat[idx].LineEvtType     = 0;    
          this.cat[idx].uiOutLineNumber = 0; 
          this.cat[idx].uiOutValue      = 0;      
          this.cat[idx].uiOutDelay      = 0;      
          this.cat[idx].cnt             = 0;
      }
          
      // Raise the flag... somethig new has just arrived
      this.bCatcherInfoNew = 1;
  } // IF valid data
  ////////////////////////////////////////////////////////////

  // Catcher counters... (Packet x5 cnt)
  TempLoc = getXMLValue(xmlData, 'cat_cnt0');
  if (TempLoc) {
    var TempArr = TempLoc.split(',');
    var len = TempArr.length;
    if (len != 6) return;
    var PackId = parseInt(TempArr[0]);
    if (PackId >= 5) return;
    for (i = 0; i < 5; i++) {
      this.cat[PackId * 5 + i].cnt = parseInt(TempArr[1 + i]);
      if (this.cat[PackId * 5 + i].cnt == -1)
        this.cat[PackId * 5 + i].cnt = '-';
    }
    // Raise the flag... somethig new has just arrived
    this.bCatcherCntNew = 1;
  } // IF valid data  
 
    this.fw_load  = false;
  }
    
  this.Run = function(){
    setTimeout( "newAJAXCommand('status.xml', updateStatusJerome, true)", 1000 );
  }
}


var bJeromeExists_XX  = false;
var ObjJerome_XX      = null;

function GetJeromeObject() {
  if( !bJeromeExists_XX ) {
     ObjJerome_XX = new JeromeObject();
     bJeromeExists_XX = true;
  }  
  return ObjJerome_XX;
}

function updateStatusJerome( xmlData ) {
  ObjJerome_XX.UpdateStatus( xmlData );   
}